=== debian/changelog ===
ghc6 (6.12.3-1ubuntu7) natty; urgency=low

  * d/rules: Install /usr/share/haddock-$VERSION in ghc6-haddock package;
    these files which are required by haddock. (LP: #749963)
  * d/control:
    + Add Replaces on ghc6-doc (<= ubuntu6) for the above change,
      as files now move from ghc6-doc to ghc6-haddock.
    + Make ghc6-haddock depend on ghc6 (taken from Debian)

 -- Iain Lane <laney@ubuntu.com>  Mon, 04 Apr 2011 09:30:30 +0100

ghc6 (6.12.3-1ubuntu6) natty; urgency=low

  * d/scripts.mk, d/ghc6.triggers.in: Make trigger file dynamic on the
    upstream version number; previously hardcoded the GHC version number
    which meant that the trigger would never have fired. Fix taken from
    Debian's darcs repository.

 -- Iain Lane <laney@ubuntu.com>  Tue, 15 Mar 2011 13:37:17 +0000

ghc6 (6.12.3-1ubuntu5) natty; urgency=low

  * Compile with -mminimal-toc on ppc64.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 24 Feb 2011 17:02:50 +0000

ghc6 (6.12.3-1ubuntu4) natty; urgency=low

  * Do not provide libghc6-utf8-string-dev, because utf8-string is no
    longer installed.  (LP: #706215)

 -- Anders Kaseorg <andersk@mit.edu>  Sat, 22 Jan 2011 03:49:36 -0500

ghc6 (6.12.3-1ubuntu3) natty; urgency=low

  * d/p/rts-types-ftbfs: Rename eventlog-postlogmsg-ftbfs to
    rts-types-ftbfs as the armel build now fails with a similar error at a
    different location. Patch that one too.

 -- Iain Lane <laney@ubuntu.com>  Mon, 17 Jan 2011 08:56:20 +0000

ghc6 (6.12.3-1ubuntu2) natty; urgency=low

  * d/p/eventlog-postlogmsg-ftbfs: Add new patch to pass a pointer in the
    4th argument, resolving FTBFS on armel

 -- Iain Lane <laney@ubuntu.com>  Fri, 14 Jan 2011 09:49:19 +0000

ghc6 (6.12.3-1ubuntu1) natty; urgency=low

  * Merge with Debian experimental, remaining changes:
    + debian/patches/linker-scripts: Backport upstream patch from trac#2615
      to resolve runtime failure when explicitly linking with -lpthread due
      to it being a linker script (introduced in ubuntu2). (LP: #689496)
    + debian/patches/unix-pthread-trac-4523: Apply patch from upstream BTS #4523
      to add missing linker reference to pthread, which caused linking
      failures in depending packages when attempting to link with the unix
      library on armel.

 -- Iain Lane <laney@ubuntu.com>  Tue, 11 Jan 2011 23:30:15 +0000

ghc6 (6.12.3-1) experimental; urgency=low

  * New upstream release
    * ghci :m now works with module names containing ' (Closes: #580568)
  * Put haddock and the shared libraries into their own packages.
    (Closes: #571537)
  * Only insert packages in gen_contents_index which are both registered
    and for which the html directory exists.
  * Use ghc-pkg --global in ghc6's trigger to avoid accessing HOME.
    (Closes: #578679)
  * Fix directories in haddock manpage.  (Closes: #578321)
  * Apply some patches from Gentoo (thanks, Sergei Trofimovich) hopefully
    fixing ia64 build.
  * Downgrade ghc6's dependency on perl to Suggests and have ghc6-doc
    depend on perl.  (Closes: #553332)
  * Standards-Version 3.9.0 (no changes necessary)
  * ghc6 package now provides ghc6-ghci on architectures where it's
    supported (i386 and amd64 only currently).

 -- Kari Pahula <kaol@debian.org>  Tue, 20 Jul 2010 19:19:20 +0300

ghc6 (6.12.1-13ubuntu3) natty; urgency=low

  * debian/patches/linker-scripts: Backport upstream patch from trac#2615
    to resolve runtime failure when explicitly linking with -lpthread due
    to it being a linker script (introduced in ubuntu2). (LP: #689496)

 -- Iain Lane <laney@ubuntu.com>  Mon, 13 Dec 2010 11:52:36 +0000

ghc6 (6.12.1-13ubuntu2) natty; urgency=low

  * debian/patches/unix-pthread-trac-4523: Apply patch from upstream BTS #4523
    to add missing linker reference to pthread, which caused linking failuers in
    depending packages when attempting to link with the unix library on armel.
  * debian/rules, debian/patches/ghc-pkg-pthread: Add -optl-pthread to
    explicitly link with -lpthread. This is a temporary fix to make the
    GHC used for bootstrapping work correctly on armel.

 -- Iain Lane <laney@ubuntu.com>  Sun, 05 Dec 2010 12:26:59 +0000
